#include <allegro.h>
#include <alpnm.h>

#define GFX GFX_AUTODETECT_WINDOWED
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480

int main() {

    int depth;
    char *filename = "winamp.ppm";

    allegro_init();
    install_keyboard();

    set_window_title(filename);

    if ((depth = desktop_color_depth()) != 0)
        set_color_depth(depth);
    else {

        allegro_message("Error getting desktop colour depth.\n");
        return 1;

    }

    if (set_gfx_mode(GFX, SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_WIDTH, SCREEN_HEIGHT) != 0) {

        allegro_message("Couldn't set graphics mode: %dx%d.\n", SCREEN_WIDTH, SCREEN_HEIGHT);
        return 1;

    }

    BITMAP *bmp = load_pnm(filename);
    if(!bmp) {

        allegro_message("error opening \"%s\"", filename);
        return 1;

    }

    clear_bitmap(screen);

    blit(bmp, screen, 0, 0, (screen->w - bmp->w) / 2, (screen->h - bmp->h) / 2, bmp->w, bmp->h);
    textout_centre_ex(screen, font, filename, SCREEN_W / 2, 10, makecol(255, 255, 255), makecol(0, 0, 0));

    while (!key[KEY_ESC]) {}
    return 0;

}
END_OF_MAIN()
