#include <allegro.h>
#include <alpnm.h>

#define GFX GFX_AUTODETECT_WINDOWED
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480

int main() {

    int depth;

    allegro_init();
    install_keyboard();
    install_mouse();

    set_window_title("alpnm save example");

    if ((depth = desktop_color_depth()) != 0)
        set_color_depth(depth);
    else {

        allegro_message("Error getting desktop colour depth.\n");
        return 1;

    }

    if (set_gfx_mode(GFX, SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_WIDTH, SCREEN_HEIGHT) != 0) {

        allegro_message("Couldn't set graphics mode: %dx%d.\n", SCREEN_WIDTH, SCREEN_HEIGHT);
        return 1;

    }

    clear_to_color(screen, makecol(255, 255, 255));
    textout_centre_ex(screen, font, "Press ESC to save and exit", SCREEN_W / 2, 10, makecol(0, 0, 0),  makecol(255, 255, 255));

    show_mouse(screen);

    BITMAP *buffer = create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT - 30);
    if (!buffer) {

        allegro_message("Error creating buffer.");
        return 1;

    }

    clear_to_color(buffer, makecol(255, 255, 255));

    while (!key[KEY_ESC]) {

        if(mouse_b & 1)
            circlefill(buffer, mouse_x, mouse_y - 30, 3, makecol(24, 100, 140));

        scare_mouse();
        blit(buffer, screen, 0, 0, 0, 30, buffer->w, buffer->h);
        unscare_mouse();

        rest(1);

    }

    save_pnm(buffer, "out.pbm", PBM_BINARY, "Yay, Allegro");
    save_pnm(buffer, "out.pgm", PGM_ASCII, "Yay, Allegro");
    save_pnm(buffer, "out.ppm", PPM_BINARY, "Yay, Allegro");

    return 0;

}
END_OF_MAIN()

